package dao

import org.jetbrains.exposed.dao.IntEntity
import org.jetbrains.exposed.dao.IntEntityClass
import org.jetbrains.exposed.dao.id.EntityID
import org.jetbrains.exposed.dao.id.IntIdTable

object ItemsV2 : IntIdTable() {
    val list = integer("list")
    val content = varchar("content", 256)
    val position = integer("position").nullable()
    val checked = bool("checked").default(false)
}

class ItemV2(id: EntityID<Int>) : IntEntity(id) {
    companion object : IntEntityClass<ItemV2>(ItemsV2)

    var list by ItemsV2.list
    var content by ItemsV2.content
    var position by ItemsV2.position
    var checked by ItemsV2.checked


}
fun ItemV2.toView(): ItemView {
    return ItemView(this.id.value, this.content, this.checked, this.position)
}

data class ItemView(val id: Int, val content: String, val checked: Boolean = false, val position: Int?)

data class ItemPatchView(val id: Int, val content: String?, val checked: Boolean?, val position: Int?)